"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudIntegrationAppDynamics = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Wavefront Cloud Integration for AppDynamics. This allows AppDynamics cloud integrations to be created,
 * updated, and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const appDynamics = new wavefront.CloudIntegrationAppDynamics("app_dynamics", {
 *     name: "Test Integration",
 *     userName: "example",
 *     controllerName: "exampleController",
 *     encryptedPassword: "encryptedPassword",
 * });
 * ```
 *
 * ## Import
 *
 * AppDynamic Cloud Integrations can be imported by using the `id`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/cloudIntegrationAppDynamics:CloudIntegrationAppDynamics app_dynamics a411c16b-3cf7-4f03-bf11-8ca05aab898d
 * ```
 */
class CloudIntegrationAppDynamics extends pulumi.CustomResource {
    /**
     * Get an existing CloudIntegrationAppDynamics resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new CloudIntegrationAppDynamics(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of CloudIntegrationAppDynamics.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CloudIntegrationAppDynamics.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["additionalTags"] = state ? state.additionalTags : undefined;
            resourceInputs["appFilterRegexes"] = state ? state.appFilterRegexes : undefined;
            resourceInputs["controllerName"] = state ? state.controllerName : undefined;
            resourceInputs["enableAppInfraMetrics"] = state ? state.enableAppInfraMetrics : undefined;
            resourceInputs["enableBackendMetrics"] = state ? state.enableBackendMetrics : undefined;
            resourceInputs["enableBusinessTrxMetrics"] = state ? state.enableBusinessTrxMetrics : undefined;
            resourceInputs["enableErrorMetrics"] = state ? state.enableErrorMetrics : undefined;
            resourceInputs["enableIndividualNodeMetrics"] = state ? state.enableIndividualNodeMetrics : undefined;
            resourceInputs["enableOverallPerfMetrics"] = state ? state.enableOverallPerfMetrics : undefined;
            resourceInputs["enableRollup"] = state ? state.enableRollup : undefined;
            resourceInputs["enableServiceEndpointMetrics"] = state ? state.enableServiceEndpointMetrics : undefined;
            resourceInputs["encryptedPassword"] = state ? state.encryptedPassword : undefined;
            resourceInputs["forceSave"] = state ? state.forceSave : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["service"] = state ? state.service : undefined;
            resourceInputs["serviceRefreshRateInMinutes"] = state ? state.serviceRefreshRateInMinutes : undefined;
            resourceInputs["userName"] = state ? state.userName : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.controllerName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'controllerName'");
            }
            if ((!args || args.encryptedPassword === undefined) && !opts.urn) {
                throw new Error("Missing required property 'encryptedPassword'");
            }
            if ((!args || args.service === undefined) && !opts.urn) {
                throw new Error("Missing required property 'service'");
            }
            if ((!args || args.userName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'userName'");
            }
            resourceInputs["additionalTags"] = args ? args.additionalTags : undefined;
            resourceInputs["appFilterRegexes"] = args ? args.appFilterRegexes : undefined;
            resourceInputs["controllerName"] = args ? args.controllerName : undefined;
            resourceInputs["enableAppInfraMetrics"] = args ? args.enableAppInfraMetrics : undefined;
            resourceInputs["enableBackendMetrics"] = args ? args.enableBackendMetrics : undefined;
            resourceInputs["enableBusinessTrxMetrics"] = args ? args.enableBusinessTrxMetrics : undefined;
            resourceInputs["enableErrorMetrics"] = args ? args.enableErrorMetrics : undefined;
            resourceInputs["enableIndividualNodeMetrics"] = args ? args.enableIndividualNodeMetrics : undefined;
            resourceInputs["enableOverallPerfMetrics"] = args ? args.enableOverallPerfMetrics : undefined;
            resourceInputs["enableRollup"] = args ? args.enableRollup : undefined;
            resourceInputs["enableServiceEndpointMetrics"] = args ? args.enableServiceEndpointMetrics : undefined;
            resourceInputs["encryptedPassword"] = (args === null || args === void 0 ? void 0 : args.encryptedPassword) ? pulumi.secret(args.encryptedPassword) : undefined;
            resourceInputs["forceSave"] = args ? args.forceSave : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["service"] = args ? args.service : undefined;
            resourceInputs["serviceRefreshRateInMinutes"] = args ? args.serviceRefreshRateInMinutes : undefined;
            resourceInputs["userName"] = args ? args.userName : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["encryptedPassword"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(CloudIntegrationAppDynamics.__pulumiType, name, resourceInputs, opts);
    }
}
exports.CloudIntegrationAppDynamics = CloudIntegrationAppDynamics;
/** @internal */
CloudIntegrationAppDynamics.__pulumiType = 'wavefront:index/cloudIntegrationAppDynamics:CloudIntegrationAppDynamics';
//# sourceMappingURL=cloudIntegrationAppDynamics.js.map