"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudIntegrationNewRelic = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Wavefront Cloud Integration for New Relic. This allows New Relic cloud integrations to be created,
 * updated, and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const newrelic = new wavefront.CloudIntegrationNewRelic("newrelic", {
 *     name: "Test Integration",
 *     apiKey: "example-api-key",
 * });
 * ```
 *
 * ## Import
 *
 * NewRelic Integrations can be imported by using the `id`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/cloudIntegrationNewRelic:CloudIntegrationNewRelic newrelic a411c16b-3cf7-4f03-bf11-8ca05aab898d
 * ```
 */
class CloudIntegrationNewRelic extends pulumi.CustomResource {
    /**
     * Get an existing CloudIntegrationNewRelic resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new CloudIntegrationNewRelic(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of CloudIntegrationNewRelic.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CloudIntegrationNewRelic.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["additionalTags"] = state ? state.additionalTags : undefined;
            resourceInputs["apiKey"] = state ? state.apiKey : undefined;
            resourceInputs["appFilterRegex"] = state ? state.appFilterRegex : undefined;
            resourceInputs["forceSave"] = state ? state.forceSave : undefined;
            resourceInputs["hostFilterRegex"] = state ? state.hostFilterRegex : undefined;
            resourceInputs["metricFilters"] = state ? state.metricFilters : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["service"] = state ? state.service : undefined;
            resourceInputs["serviceRefreshRateInMinutes"] = state ? state.serviceRefreshRateInMinutes : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.apiKey === undefined) && !opts.urn) {
                throw new Error("Missing required property 'apiKey'");
            }
            if ((!args || args.service === undefined) && !opts.urn) {
                throw new Error("Missing required property 'service'");
            }
            resourceInputs["additionalTags"] = args ? args.additionalTags : undefined;
            resourceInputs["apiKey"] = (args === null || args === void 0 ? void 0 : args.apiKey) ? pulumi.secret(args.apiKey) : undefined;
            resourceInputs["appFilterRegex"] = args ? args.appFilterRegex : undefined;
            resourceInputs["forceSave"] = args ? args.forceSave : undefined;
            resourceInputs["hostFilterRegex"] = args ? args.hostFilterRegex : undefined;
            resourceInputs["metricFilters"] = args ? args.metricFilters : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["service"] = args ? args.service : undefined;
            resourceInputs["serviceRefreshRateInMinutes"] = args ? args.serviceRefreshRateInMinutes : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["apiKey"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(CloudIntegrationNewRelic.__pulumiType, name, resourceInputs, opts);
    }
}
exports.CloudIntegrationNewRelic = CloudIntegrationNewRelic;
/** @internal */
CloudIntegrationNewRelic.__pulumiType = 'wavefront:index/cloudIntegrationNewRelic:CloudIntegrationNewRelic';
//# sourceMappingURL=cloudIntegrationNewRelic.js.map